Skip to content
Start here

Create a namespace

client.KV.Namespaces.New(ctx, params) (*Namespace, error)
POST/accounts/{account_id}/storage/kv/namespaces

Creates a Workers KV namespace in the specified account with the given title. Returns 400 if the account already owns a namespace with that title; an existing namespace must be explicitly deleted before it can be replaced. An optional jurisdiction restricts where data is durably stored and can only be set at creation time.

Security
API Token

The preferred authorization scheme for interacting with the Cloudflare API. Create a token.

Example:Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY
API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
Accepted Permissions (at least one required)
Workers KV Storage Write
ParametersExpand Collapse
params NamespaceNewParams
AccountID param.Field[string]

Path param: ID of the Cloudflare account that owns the Workers KV namespaces.

maxLength32
Title param.Field[string]

Body param: Human-readable string name for a Workers KV namespace.

maxLength512
Jurisdiction param.Field[NamespaceNewParamsJurisdiction]Optional

Body param: Specify the jurisdiction to restrict the KV namespace to durably store data within. Can only be set at namespace creation time.

const NamespaceNewParamsJurisdictionEu NamespaceNewParamsJurisdiction = "eu"
const NamespaceNewParamsJurisdictionFedramp NamespaceNewParamsJurisdiction = "fedramp"
const NamespaceNewParamsJurisdictionUs NamespaceNewParamsJurisdiction = "us"
Mode param.Field[NamespaceNewParamsMode]Optional

Body param: The mode of the Workers KV namespace. Specify instant when creating a namespace to create a KV Instant namespace. Omit this field when creating a namespace to create a classic namespace. Currently, instant is the only supported explicit value.

const NamespaceNewParamsModeInstant NamespaceNewParamsMode = "instant"
ReturnsExpand Collapse
type Namespace struct{…}
ID string

ID of the Workers KV namespace.

maxLength32
Title string

Human-readable string name for a Workers KV namespace.

maxLength512
Jurisdiction NamespaceJurisdictionOptional

Specify the jurisdiction to restrict the KV namespace to durably store data within. Can only be set at namespace creation time.

One of the following:
const NamespaceJurisdictionEu NamespaceJurisdiction = "eu"
const NamespaceJurisdictionFedramp NamespaceJurisdiction = "fedramp"
const NamespaceJurisdictionUs NamespaceJurisdiction = "us"
Mode NamespaceModeOptional

The mode of the Workers KV namespace. Specify instant when creating a namespace to create a KV Instant namespace. Omit this field when creating a namespace to create a classic namespace. Currently, instant is the only supported explicit value.

SupportsURLEncoding boolOptional

True if keys written on the URL will be URL-decoded before storing. For example, if set to “true”, a key written on the URL as “%3F” will be stored as ”?”.

Create a namespace

package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/kv"
  "github.com/cloudflare/cloudflare-go/option"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"),
  )
  namespace, err := client.KV.Namespaces.New(context.TODO(), kv.NamespaceNewParams{
    AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"),
    Title: cloudflare.F("My Own Namespace"),
  })
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", namespace.ID)
}
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "id": "0f2ac74b498b48028cb68387c421e279",
    "title": "My Own Namespace",
    "jurisdiction": "eu",
    "mode": "instant",
    "supports_url_encoding": true
  }
}
Returns Examples
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "id": "0f2ac74b498b48028cb68387c421e279",
    "title": "My Own Namespace",
    "jurisdiction": "eu",
    "mode": "instant",
    "supports_url_encoding": true
  }
}